/*******************************************************************
 * This is a demonstration of the use of a function template.
 *******************************************************************/

#include<iostream>
#include<string>
#include<vector>
#include<string>
using namespace std;
/* If b and e are iterators to a container
 * of objects of type T, then my_count returns the number of occurences
 * of the value t in [b,e).
 */ 	
template <class iterator, class T>
int my_count(const iterator & b, const iterator & e, T t);


int main()
{
	float x;
	vector<float> nums;
	string trash;
	cout<<"Please enter some floating point values. "<<
		"Enter 's' to stop. ";
	while(cin>>x)
		nums.push_back(x);
	cin.clear();
	cin>>trash;//Get the stop word to discard.
	cout<<"\nFor what value would you like to count occurrences?  ";
	cin>>x;
	cout<<"\nThere are "<<my_count(nums.begin(),nums.end(), x)
		<<" occurrences of "<<x<<".\n";
	return 0;
}

template <class iterator, class T>
int my_count(const iterator & b, const iterator & e, T t)
{
	int ret=0;
	for(iterator it=b; it!=e; it++)
		if(*it==t)
			ret++;
	return ret;
}
